---
title: white-space
slug: Web/CSS/white-space
tags:
  - CSS
  - CSS Property
  - CSS Text
  - Reference
  - 'recipe:css-property'
  - white-space
---
<div>{{CSSRef}}</div>

<p>The <strong><code>white-space</code></strong> CSS property sets how {{Glossary("whitespace", "white space")}} inside an element is handled.</p>

<div>{{EmbedInteractiveExample("pages/css/white-space.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div class="note">
<p><strong>Note:</strong> To make words break <em>within themselves</em>, use {{CSSxRef("overflow-wrap")}}, {{CSSxRef("word-break")}}, or {{CSSxRef("hyphens")}} instead.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">/* Keyword values */
white-space: normal;
white-space: nowrap;
white-space: pre;
white-space: pre-wrap;
white-space: pre-line;
white-space: break-spaces;

/* Global values */
white-space: inherit;
white-space: initial;
white-space: unset;
</pre>

<p>The <code>white-space</code> property is specified as a single keyword chosen from the list of values below.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>normal</code></dt>
 <dd>Sequences of white space are collapsed. Newline characters in the source are handled the same as other white space. Lines are broken as necessary to fill line boxes.</dd>
 <dt><code>nowrap</code></dt>
 <dd>Collapses white space as for <code>normal</code>, but suppresses line breaks (text wrapping) within the source.</dd>
 <dt><code>pre</code></dt>
 <dd>Sequences of white space are preserved. Lines are only broken at newline characters in the source and at {{HTMLElement("br")}} elements.</dd>
 <dt><code>pre-wrap</code></dt>
 <dd>Sequences of white space are preserved. Lines are broken at newline characters, at {{HTMLElement("br")}}, and as necessary to fill line boxes.</dd>
 <dt><code>pre-line</code></dt>
 <dd>Sequences of white space are collapsed. Lines are broken at newline characters, at {{HTMLElement("br")}}, and as necessary to fill line boxes.</dd>
 <dt><code>break-spaces</code></dt>
 <dd>The behavior is identical to that of <code>pre-wrap</code>, except that:
 <ul>
  <li>Any sequence of preserved white space always takes up space, including at the end of the line.</li>
  <li>A line breaking opportunity exists after every preserved white space character, including between white space characters.</li>
  <li>Such preserved spaces take up space and do not hang, and thus affect the box’s intrinsic sizes (min-content size and max-content size).</li>
 </ul>
 </dd>
</dl>

<p>The following table summarizes the behavior of the various <code>white-space</code> values:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th></th>
   <th>New lines</th>
   <th>Spaces and tabs</th>
   <th>Text wrapping</th>
   <th>End-of-line spaces</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th><code>normal</code></th>
   <td>Collapse</td>
   <td>Collapse</td>
   <td>Wrap</td>
   <td>Remove</td>
  </tr>
  <tr>
   <th><code>nowrap</code></th>
   <td>Collapse</td>
   <td>Collapse</td>
   <td>No wrap</td>
   <td>Remove</td>
  </tr>
  <tr>
   <th><code>pre</code></th>
   <td>Preserve</td>
   <td>Preserve</td>
   <td>No wrap</td>
   <td>Preserve</td>
  </tr>
  <tr>
   <th><code>pre-wrap</code></th>
   <td>Preserve</td>
   <td>Preserve</td>
   <td>Wrap</td>
   <td>Hang</td>
  </tr>
  <tr>
   <th><code>pre-line</code></th>
   <td>Preserve</td>
   <td>Collapse</td>
   <td>Wrap</td>
   <td>Remove</td>
  </tr>
  <tr>
   <th><code>break-spaces</code></th>
   <td>Preserve</td>
   <td>Preserve</td>
   <td>Wrap</td>
   <td>Wrap</td>
  </tr>
 </tbody>
</table>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_example">Basic example</h3>

<pre class="brush: css notranslate">code {
  white-space: pre;
}</pre>

<h3 id="Line_breaks_inside_pre_elements">Line breaks inside &lt;pre&gt; elements</h3>

<pre class="brush: css notranslate">pre {
  word-wrap: break-word;      /* IE 5.5-7 */
  white-space: pre-wrap;      /* Modern browsers */
}</pre>

<h3 id="In_action">In action</h3>

<h4 id="HTML">HTML</h4>

<div class="hidden" id="See_it_in_action_LiveSample">
<pre class="brush: html notranslate">&lt;div id="css-code" class="box"&gt;
  p { white-space:
  &lt;select&gt;
    &lt;option&gt;normal&lt;/option&gt;
    &lt;option&gt;nowrap&lt;/option&gt;
    &lt;option&gt;pre&lt;/option&gt;
    &lt;option&gt;pre-wrap&lt;/option&gt;
    &lt;option&gt;pre-line&lt;/option&gt;
    &lt;option&gt;break-spaces&lt;/option&gt;
  &lt;/select&gt; }
&lt;/div&gt;
&lt;div id="results" class="box"&gt;
  &lt;p&gt;    Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.

    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.

    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.

    Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.&lt;/p&gt;
&lt;/div&gt;</pre>

<pre class="brush: css notranslate">.box {
  width: 300px;
  padding: 16px;
  border-radius: 10px;
}

#css-code {
  background-color: rgb(220, 220, 220);
  font-size: 16px;
  font-family: monospace;
}

#css-code select {
  font-family: inherit;
}

#results {
  background-color: rgb(230, 230, 230);
  overflow-x: scroll;
  height: 400px;
  white-space: normal;
  font-size: 14px;
}</pre>

<pre class="brush: js notranslate">var select  = document.querySelector("#css-code select");
var results = document.querySelector("#results p");
select.addEventListener("change", function(e) {
  results.setAttribute("style", "white-space: "+e.target.value);
})</pre>
</div>

<pre class="brush: html notranslate">&lt;p&gt; Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.&lt;/p&gt; </pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("In_action", "100%", 500)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS3 Text", "#propdef-white-space", "white-space")}}</td>
   <td>{{Spec2("CSS3 Text")}}</td>
   <td>Precisely defines the breaking algorithms.</td>
  </tr>
  <tr>
   <td>{{SpecName("CSS2.1", "text.html#white-space-prop", "white-space")}}</td>
   <td>{{Spec2("CSS2.1")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.white-space")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Properties that define how words break <em>within themselves</em>: {{CSSxRef("overflow-wrap")}}, {{CSSxRef("word-break")}}, {{CSSxRef("hyphens")}}</li>
</ul>
